/* File:  XmlContext.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef XML_CONTEXT_HPP
#define XML_CONTEXT_HPP

#include <ctype.h>
#include "XString.hpp"

class XmlContext
{
public:

    XmlContext();
    ~XmlContext();

    XString XmlEncode(const XString& src);
    XString XmlAttribute(const char *, const char *);
    XString XmlAttribute(const char *, const XString &);
    XString XmlPcdata(const XString &);
    XString OpenIndent(const char *);
    XString Indent(void);
    XString IndentText(const char *);
    XString CloseIndent(const char *);

private:
    int m_indent_level;

};

#endif
