/* File:  XmlNode.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef XML_NODE_HPP
#define XML_NODE_HPP

#include "XString.hpp"
#include "TStack.hpp"
#include "xmlparse.h"

//--------------------------------------------
class XmlAttribute
{
public:
    XString key;
    XString val;
};

//--------------------------------------------
class XmlNode
{
public:
    XmlNode();
    ~XmlNode();

    XString element;
    XString pcdata;
    TStack<XmlAttribute> attributes;
    TStack<XmlNode> children;

    static XmlNode* parse(XString& msg, const XString &xml, XML_Parser &p);

private:
    static void start_cb(void *pData, const char *el, const char **attr);
    static void end_cb(void *pData, const char *el);
    static void char_cb(void *pData, const char *txt, int txtlen);
    static void dump_tree(XmlNode *pTree, int depth);

};

#endif
