/* File:  wctpXmlLookupSubscriber.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_LOOKUP_SUBSCRIBER_HPP
#define WCTP_XML_LOOKUP_SUBSCRIBER_HPP

#include "wctpXmlOperation.hpp"
#include "wctpXmlOriginator.hpp"
#include "wctpXmlLookupMessageControl.hpp"
#include "wctpXmlRecipient.hpp"

class wctpXmlLookupSubscriber : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlLookupSubscriber(); 
    wctpXmlLookupSubscriber(const wctpXmlLookupSubscriber &); 
    ~wctpXmlLookupSubscriber(); 
    wctpXmlLookupSubscriber& operator=(const wctpXmlLookupSubscriber &);

    ////////////////////////////
    // reset object to default state 
    virtual void 
    Clear(void);

    ////////////////////////////
    // Originator Child Element (always holds)
    wctpXmlOriginator* 
    GetOriginator(void);

    ////////////////////////////
    // LookupMessageControl Child Element (always holds)
    wctpXmlLookupMessageControl* 
    GetLookupMessageControl(void);

    ////////////////////////////
    // Recipient Child Element (always holds)
    wctpXmlRecipient* 
    GetRecipient(void);

    void 
    SetXmlString(const char* newValue);

private:
    virtual void 
    Init(void);

    virtual void 
    Copy(const wctpXmlLookupSubscriber &);

    virtual void 
    Free(void);

    virtual XString 
    AssembleOperation(XmlContext& ctx);

    virtual wctp_parse_t 
    ParseObject(XString& msg, XmlNode *pTree);
    
    // attributes
    wctpXmlOriginator           *m_pOriginator;
    wctpXmlLookupMessageControl *m_pLookupMessageControl;
    wctpXmlRecipient            *m_pRecipient;
    
};
#endif
