/* File:  wctpXmlSubmitClientResponse.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_SUBMIT_CLIENT_RESPONSE_HPP
#define WCTP_XML_SUBMIT_CLIENT_RESPONSE_HPP

#include "wctpXmlFailure.hpp"
#include "wctpXmlClientSuccess.hpp"
#include "wctpXmlOperation.hpp"

class wctpXmlSubmitClientResponse : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlSubmitClientResponse(); 
    wctpXmlSubmitClientResponse(const wctpXmlSubmitClientResponse &); 
    ~wctpXmlSubmitClientResponse(); 
    wctpXmlSubmitClientResponse& operator=(const wctpXmlSubmitClientResponse &);

    ////////////////////////////
    // reset object to default state 
    virtual void 
    Clear(void);

    ////////////////////////////
    // SubmitClientResponse Type
    wctp_xml_t 
    GetSubmitClientResponseType(void);

    ////////////////////////////
    // Failure Child Element (holds only one of set)
    wctpXmlFailure* 
    GetFailure(void);
    void // specify to hold this item from the set
    HoldFailure(void);

    ////////////////////////////
    // ClientSuccess Child Element (holds only one of set)
    wctpXmlClientSuccess* 
    GetClientSuccess(void);
    void // specify to hold this item from the set
    HoldClientSuccess(void);

private:
    virtual void 
    Init(void);

    virtual void 
    Copy(const wctpXmlSubmitClientResponse &);

    virtual void 
    Free(void);

    virtual XString 
    AssembleOperation(XmlContext& ctx);

    virtual wctp_parse_t 
    ParseObject(XString& msg, XmlNode *pTree);
    
    wctp_parse_t 
    ParseObjectSwitch(XString& msg, XmlNode *pTree, int& pos);

    // attributes
    wctp_xml_t             m_SubmitClientResponseType;
    wctpXmlFailure        *m_pFailure;
    wctpXmlClientSuccess  *m_pClientSuccess;
    
};
#endif
