/* File:  wctpXmlVersionDTDSupport.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_VERSION_DTD_SUPPORT_HPP
#define WCTP_XML_VERSION_DTD_SUPPORT_HPP

#include "wctpXmlOperation.hpp"

class wctpXmlVersionDTDSupport : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlVersionDTDSupport(); 
    wctpXmlVersionDTDSupport(const wctpXmlVersionDTDSupport &); 
    ~wctpXmlVersionDTDSupport(); 
    wctpXmlVersionDTDSupport& operator=(const wctpXmlVersionDTDSupport &);

    ////////////////////////////
    // Assemble XML protocol text
    virtual XString 
    AssembleOperation(XmlContext& ctx);

    ////////////////////////////
    // Parse XML protocol text
    virtual wctp_parse_t 
    ParseObject(XString& msg, XmlNode *pTree);
    
    ////////////////////////////
    // email attribute
    const char * 
    GetDTDName(void) const;
    void  
    SetDTDName(const char *);

    ////////////////////////////
    // phone attribute
    const char * 
    GetSupportType(void) const;
    void  
    SetSupportType(const char *);

    ////////////////////////////
    // www attribute
    const char * 
    GetExceptions(void) const;
    void  
    SetExceptions(const char *);

    ////////////////////////////
    // info attribute
    const char * 
    GetSupportUntil(void) const;
    void  
    SetSupportUntil(const char *);

    ////////////////////////////
    // www attribute
    const char * 
    GetReplacement(void) const;
    void  
    SetReplacement(const char *);

    ////////////////////////////
    // info attribute
    const char * 
    GetVerToken(void) const;
    void  
    SetVerToken(const char *);

private:
    virtual void 
    Init(void);

    virtual void 
    Copy(const wctpXmlVersionDTDSupport &);

    wctp_parse_t 
    ParseAttribute(XString& msg, const XString& key, const XString& val);

    // attributes
    XString m_dtdName;
    XString m_supportType;
    XString m_exceptions;
    XString m_supportUntil;
    XString m_replacement;
    XString m_verToken;
    
};
#endif
