/* File:  wctpXmlVersionQuery.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_VERSION_QUERY_HPP
#define WCTP_XML_VERSION_QUERY_HPP

#include "wctpXmlOperation.hpp"

class wctpXmlVersionQuery : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlVersionQuery(); 
    wctpXmlVersionQuery(const wctpXmlVersionQuery &); 
    ~wctpXmlVersionQuery(); 
    wctpXmlVersionQuery& operator=(const wctpXmlVersionQuery &);

    ////////////////////////////
    // reset object to default state 
    virtual void 
    Clear(void);

    ////////////////////////////
    // inquirer attribute
    const char * 
    GetInquirer(void) const;
    void  
    SetInquirer(const char *);

    ////////////////////////////
    // datetime attribute
    const char * 
    GetDateTime(void) const;
    void  
    SetDateTime(const char *);

    ////////////////////////////
    // wctpToken attribute
    const char * 
    GetWctpToken(void) const;
    void  
    SetWctpToken(const char *);

private:
    virtual void Init(void);
    virtual void Copy(const wctpXmlVersionQuery &);
    virtual void Free(void);

    virtual XString 
    AssembleOperation(XmlContext& ctx);

    virtual wctp_parse_t 
    ParseObject(XString& msg, XmlNode *pTree);
    
    wctp_parse_t 
    ParseAttribute(XString& msg, const XString& key, const XString& val);

    // attributes
    XString m_inquirer;
    XString m_dateTime;
    XString m_wctpToken;
    
};
#endif
